# avenc_truehd

libav truehd encoder

## Hierarchy

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstAudioEncoder
                        ╰──avenc_truehd

## Implemented interfaces

    GstPreset

## Factory details

Authors: – Wim Taymans <wim.taymans@gmail.com>, Ronald Bultje <rbultje@ronald.bitfreak.net></rbultje@ronald.bitfreak.net></wim.taymans@gmail.com>

Classification: – `Codec/Encoder/Audio`

Rank – secondary

Plugin – libav

Package – GStreamer FFMPEG Plug-ins

## Pad Templates

### `sink`

    audio/x-raw:
           channels: 1
               rate: { (int)44100, (int)48000, (int)88200, (int)96000, (int)176400, (int)192000 }
             format: { S16LE, S32LE }
             layout: interleaved
    audio/x-raw:
           channels: 2
               rate: { (int)44100, (int)48000, (int)88200, (int)96000, (int)176400, (int)192000 }
             format: { S16LE, S32LE }
             layout: interleaved
    audio/x-raw:
           channels: 3
       channel-mask: 0x000000000000000b
               rate: { (int)44100, (int)48000, (int)88200, (int)96000, (int)176400, (int)192000 }
             format: { S16LE, S32LE }
             layout: interleaved
    audio/x-raw:
           channels: 3
       channel-mask: 0x0000000000000007
               rate: { (int)44100, (int)48000, (int)88200, (int)96000, (int)176400, (int)192000 }
             format: { S16LE, S32LE }
             layout: interleaved
    audio/x-raw:
           channels: 4
       channel-mask: 0x000000000000000f
               rate: { (int)44100, (int)48000, (int)88200, (int)96000, (int)176400, (int)192000 }
             format: { S16LE, S32LE }
             layout: interleaved
    audio/x-raw:
           channels: 4
       channel-mask: 0x0000000000000107
               rate: { (int)44100, (int)48000, (int)88200, (int)96000, (int)176400, (int)192000 }
             format: { S16LE, S32LE }
             layout: interleaved
    audio/x-raw:
           channels: 5
       channel-mask: 0x000000000000010f
               rate: { (int)44100, (int)48000, (int)88200, (int)96000, (int)176400, (int)192000 }
             format: { S16LE, S32LE }
             layout: interleaved
    audio/x-raw:
           channels: 5
       channel-mask: 0x0000000000000c07
               rate: { (int)44100, (int)48000, (int)88200, (int)96000, (int)176400, (int)192000 }
             format: { S16LE, S32LE }
             layout: interleaved
    audio/x-raw:
           channels: 6
       channel-mask: 0x0000000000000c0f
               rate: { (int)44100, (int)48000, (int)88200, (int)96000, (int)176400, (int)192000 }
             format: { S16LE, S32LE }
             layout: interleaved

Presence – always

Direction – sink

Object type – GstPad

### `src`

    audio/x-true-hd:
           channels: [ 1, 8 ]
               rate: [ 4000, 96000 ]

Presence – always

Direction – src

Object type – GstPad

## Properties

### ac

    “ac” gint

set number of audio channels (Generic codec option, might have no effect)

Flags : Read / Write

Default value : 0

### ar

    “ar” gint

set audio sampling rate (in Hz) (Generic codec option, might have no effect)

Flags : Read / Write

Default value : 0

### audio-service-type

    “audio-service-type” avcodeccontext-audio-service-type *

audio service type (Generic codec option, might have no effect)

Flags : Read / Write

Default value : ma (0)

### bitrate

    “bitrate” gint

set bitrate (in bits/s) (Generic codec option, might have no effect)

Flags : Read / Write

Default value : 128000

### bitrate-tolerance

    “bitrate-tolerance” gint

Set video bitrate tolerance (in bits/s). In 1-pass mode, bitrate tolerance specifies how far ratecontrol is willing to deviate from the target average bitrate value. This is not related to minimum/maximum bitrate. Lowering tolerance too much has an adverse effect on quality. (Generic codec option, might have no effect)

Flags : Read / Write

Default value : 4000000

### bufsize

    “bufsize” gint

set ratecontrol buffer size (in bits) (Generic codec option, might have no effect)

Flags : Read / Write

Default value : 0

### codebook-search

    “codebook-search” gint

Max number of codebook searches (Private codec option)

Flags : Read / Write

Default value : 3

### compression-level

    “compression-level” gint

(null) (Generic codec option, might have no effect)

Flags : Read / Write

Default value : -1

### cutoff

    “cutoff” gint

set cutoff bandwidth (Generic codec option, might have no effect)

Flags : Read / Write

Default value : 0

### debug

    “debug” avcodeccontext-debug *

print specific debug info (Generic codec option, might have no effect)

Flags : Read / Write

Default value : (none)

### dump-separator

    “dump-separator” gchararray

set information dump field separator (Generic codec option, might have no effect)

Flags : Read / Write

Default value : NULL

### err-detect

    “err-detect” avcodeccontext-err-detect *

set error detection flags (Generic codec option, might have no effect)

Flags : Read / Write

Default value : (none)

### export-side-data

    “export-side-data” avcodeccontext-export-side-data *

Export metadata as side data (Generic codec option, might have no effect)

Flags : Read / Write

Default value : (none)

### flags

    “flags” avcodeccontext-flags *

(null) (Generic codec option, might have no effect)

Flags : Read / Write

Default value : (none)

### flags2

    “flags2” avcodeccontext-flags2 *

(null) (Generic codec option, might have no effect)

Flags : Read / Write

Default value : (none)

### frame-size

    “frame-size” gint

(null) (Generic codec option, might have no effect)

Flags : Read / Write

Default value : 0

### global-quality

    “global-quality” gint

(null) (Generic codec option, might have no effect)

Flags : Read / Write

Default value : 0

### lpc-coeff-precision

    “lpc-coeff-precision” gint

LPC coefficient precision (Private codec option)

Flags : Read / Write

Default value : 15

### lpc-passes

    “lpc-passes” gint

Number of passes to use for Cholesky factorization during LPC analysis (Private codec option)

Flags : Read / Write

Default value : 2

### lpc-type

    “lpc-type” mlpenc-lpc-type *

LPC algorithm (Private codec option)

Flags : Read / Write

Default value : levinson (2)

### max-interval

    “max-interval” gint

Max number of frames between each new header (Private codec option)

Flags : Read / Write

Default value : 16

### max-pixels

    “max-pixels” gint64

Maximum number of pixels (Generic codec option, might have no effect)

Flags : Read / Write

Default value : 2147483647

### max-samples

    “max-samples” gint64

Maximum number of samples (Generic codec option, might have no effect)

Flags : Read / Write

Default value : 2147483647

### maxrate

    “maxrate” gint64

maximum bitrate (in bits/s). Used for VBV together with bufsize. (Generic codec option, might have no effect)

Flags : Read / Write

Default value : 0

### minrate

    “minrate” gint64

minimum bitrate (in bits/s). Most useful in setting up a CBR encode. It is of little use otherwise. (Generic codec option, might have no effect)

Flags : Read / Write

Default value : 0

### prediction-order

    “prediction-order” mlpenc-predm *

Search method for selecting prediction order (Private codec option)

Flags : Read / Write

Default value : estimation (0)

### rematrix-precision

    “rematrix-precision” gint

Rematrix coefficient precision (Private codec option)

Flags : Read / Write

Default value : 1

### strict

    “strict” avcodeccontext-strict *

how strictly to follow the standards (Generic codec option, might have no effect)

Flags : Read / Write

Default value : normal (0)

### thread-type

    “thread-type” avcodeccontext-thread-type *

select multithreading type (Generic codec option, might have no effect)

Flags : Read / Write

Default value : slice+frame

### threads

    “threads” avcodeccontext-threads *

set the number of threads (Generic codec option, might have no effect)

Flags : Read / Write

Default value : unknown (1)

### ticks-per-frame

    “ticks-per-frame” gint

(null) (Generic codec option, might have no effect)

Flags : Read / Write

Default value : 1

### trellis

    “trellis” gint

rate-distortion optimal quantization (Generic codec option, might have no effect)

Flags : Read / Write

Default value : 0

## Named constants

### mlpenc-lpc-type

#### Members

`levinson` (2) – levinson
`cholesky` (3) – cholesky

### mlpenc-predm

#### Members

`estimation` (0) – estimation
`search` (4) – search

The results of the search are